-- main tab
UI.Label("DBSF - Bot 1.0")
UI.Separator()
importStyle("/cavebot/alarms.otui")
dofile("/cavebot/alarms.lua")
local panelName = "TurnToTarget"
local ui_1 = setupUI([[
Panel
  height: 19

  BotSwitch
    id: turntotarget
    anchors.top: parent.top
    anchors.left: parent.left
    text-align: center
    width: 177
    !text: tr('Turn To Target')

]])
ui_1:setId(panelName)

if not storage[panelName] then
  storage[panelName] = {}
end

local config_1 = storage[panelName]

ui_1.turntotarget:setOn(config_1.enabled)
ui_1.turntotarget.onClick = function(widget)
  config_1.enabled = not config_1.enabled
  widget:setOn(config_1.enabled)
end
UI.Separator()
-----------
local ui_2 = UI.createWidget("PvEBotPanel")

if not PvE_Config then
	PvE_Config = {}
	local getSHChild = ui_2:getChildren()
	if getSHChild then
		for i=1, #getSHChild do
			local childPointers = getSHChild[i]
			local getStyleName = childPointers:getStyleName()
			if table.contains({"BotSwitch", "Label", "BotTextEdit", "HorizontalSeparator"}, getStyleName, true) then
				local getChildById = childPointers:getId()
				if getChildById ~= "PVE_ShowHide" then
					PvE_Config[#PvE_Config + 1] = getChildById
				end
			end
		end
	end
end

local function PvEShowChild(show)
	if show then
		for i=1, #PvE_Config do
			local childPointers = PvE_Config[i]
			local getChildById = ui_2:getChildById(childPointers)
			getChildById:show()
		end
	else
		for i=1, #PvE_Config do
			local childPointers = PvE_Config[i] 
			local getChildById = ui_2:getChildById(childPointers)
			getChildById:hide()
		end
	end
end

PvEShowChild(false)
local panelName_2 = "Attacks"
if not storage[panelName_2] then
  storage[panelName_2] = {}
end

local config_2 = storage[panelName_2]
if not config_2.PvE then
	config_2.PvE = {}
end
local PvEConfig = config_2.PvE  
--load pve config
if PvEConfig.area_text then
	ui_2:getChildById('PvE_TextEdit_AN'):setText(PvEConfig.area_text)
end
if PvEConfig.target_text then
	ui_2:getChildById('PvE_TextEdit_SN'):setText(PvEConfig.target_text)
end
if PvEConfig.target_delay then
	ui_2:getChildById('PvE_TextEdit_DL'):setText(PvEConfig.target_delay)
end
if PvEConfig.area_delay then
	ui_2:getChildById('PvE_TextEdit_ADL'):setText(PvEConfig.area_delay)
end
if PvEConfig.radius then
	ui_2:getChildById('PvE_TextEdit_RA'):setText(PvEConfig.radius)
end
if PvEConfig.radius then
	ui_2:getChildById('PvE_TextEdit_MTR'):setText(PvEConfig.minTargetRadius)
end
if PvEConfig.SH_enabled then
	PvEShowChild(PvEConfig.SH_enabled)
end
	
ui_2.PVE_ShowHide:setOn(PvEConfig.SH_enabled)
ui_2.PVE_ShowHide.onClick = function(widget)
  if PvEConfig.SH_enabled then
	PvEConfig.SH_enabled = not PvEConfig.SH_enabled
	ui_2.PVE_ShowHide:setOn(PvEConfig.SH_enabled)
	PvEShowChild(PvEConfig.SH_enabled)
  else
	PvEConfig.SH_enabled = not PvEConfig.SH_enabled
	ui_2.PVE_ShowHide:setOn(PvEConfig.SH_enabled)
	PvEShowChild(PvEConfig.SH_enabled)
  end
end

ui_2.PvEAtk:setOn(PvEConfig.enabled)
ui_2.PvEAtk.onClick = function(widget)
  PvEConfig.enabled = not PvEConfig.enabled
  widget:setOn(PvEConfig.enabled)
  PvEConfig.area_text = ui_2:getChildById('PvE_TextEdit_AN'):getText()
  PvEConfig.target_text = ui_2:getChildById('PvE_TextEdit_SN'):getText()
  local getDelayChild = ui_2:getChildById('PvE_TextEdit_DL'):getText()
  getDelayChild = tonumber(getDelayChild)
  if type(getDelayChild) ~= "number" then
	getDelayChild = 1000
	ui_2:getChildById('PvE_TextEdit_DL'):setText(getDelayChild)
  end
  PvEConfig.target_delay = getDelayChild
  local getAreaDelay = ui_2:getChildById('PvE_TextEdit_ADL'):getText()
  getAreaDelay = tonumber(getAreaDelay)
  if type(getAreaDelay) ~= "number" then
	getAreaDelay = 1000
	ui_2:getChildById('PvE_TextEdit_ADL'):setText(getAreaDelay)
  end
  PvEConfig.area_delay = getAreaDelay
  local getRadiusChild = ui_2:getChildById('PvE_TextEdit_RA'):getText()
  getRadiusChild = tonumber(getRadiusChild)
  if type(getRadiusChild) ~= "number" then
	getRadiusChild = 1000
	ui_2:getChildById('PvE_TextEdit_RA'):setText(getRadiusChild)
  end
  PvEConfig.radius = getRadiusChild  
  
  local getMinTargetRadius = ui_2:getChildById('PvE_TextEdit_MTR'):getText()
  getMinTargetRadius = tonumber(getMinTargetRadius)
  if type(getMinTargetRadius) ~= "number" then
	getMinTargetRadius = 1000
	ui_2:getChildById('PvE_TextEdit_MTR'):setText(getMinTargetRadius)
  end
  PvEConfig.minTargetRadius = getMinTargetRadius
end
ui_2.PvE_TextEdit_AN.onTextChange = function()
  PvEConfig.area_text = ui_2:getChildById('PvE_TextEdit_AN'):getText()
end
ui_2.PvE_TextEdit_SN.onTextChange = function()
  PvEConfig.target_text = ui_2:getChildById('PvE_TextEdit_SN'):getText()
end
ui_2.PvE_TextEdit_DL.onTextChange = function()
  local getDelayChild = ui_2:getChildById('PvE_TextEdit_DL'):getText()
  getDelayChild = tonumber(getDelayChild)
  if type(getDelayChild) ~= "number" then
	getDelayChild = 1000
	ui_2:getChildById('PvE_TextEdit_DL'):setText(getDelayChild)
  end
  PvEConfig.target_delay = getDelayChild
end
ui_2.PvE_TextEdit_ADL.onTextChange = function()
  local getAreaDelay = ui_2:getChildById('PvE_TextEdit_ADL'):getText()
  getAreaDelay = tonumber(getAreaDelay)
  if type(getAreaDelay) ~= "number" then
	getAreaDelay = 1000
	ui_2:getChildById('PvE_TextEdit_ADL'):setText(getAreaDelay)
  end
  PvEConfig.area_delay = getAreaDelay
end
ui_2.PvE_TextEdit_RA.onTextChange = function()
  local getRadiusChild = ui_2:getChildById('PvE_TextEdit_RA'):getText()
  getRadiusChild = tonumber(getRadiusChild)
  if type(getRadiusChild) ~= "number" then
	getRadiusChild = 1000
	ui_2:getChildById('PvE_TextEdit_RA'):setText(getRadiusChild)
  end
  PvEConfig.radius = getRadiusChild  
end
ui_2.PvE_TextEdit_MTR.onTextChange = function()
  local getMinTargetRadius = ui_2:getChildById('PvE_TextEdit_MTR'):getText()
  getMinTargetRadius = tonumber(getMinTargetRadius)
  if type(getMinTargetRadius) ~= "number" then
	getMinTargetRadius = 1000
	ui_2:getChildById('PvE_TextEdit_MTR'):setText(getMinTargetRadius)
  end
  PvEConfig.minTargetRadius = getMinTargetRadius 
end

-----------
local ui_3 = UI.createWidget("PvPBotPanel")
if not PvP_Config_1 then
	PvP_Config_1 = {}
	local getSHChild = ui_3:getChildren()
	if getSHChild then
		for i=1, #getSHChild do
			local childPointers = getSHChild[i]
			local getStyleName = childPointers:getStyleName()
			if table.contains({"BotSwitch", "Label", "BotTextEdit", "HorizontalSeparator"}, getStyleName, true) then
				local getChildById = childPointers:getId()
				if getChildById ~= "PvP_ShowHide" then
					PvP_Config_1[#PvP_Config_1 + 1] = getChildById
				end
			end
		end
		
		PvP_Config_1[#PvP_Config_1 + 1] = "botConfig"
	end
end

local function PvPShowChild_1(show)
	if show then
		for i=1, #PvP_Config_1 do
			local childPointers = PvP_Config_1[i]
			local getChildById = ui_3:getChildById(childPointers)
			getChildById:show()
		end
	else
		for i=1, #PvP_Config_1 do
			local childPointers = PvP_Config_1[i] 
			local getChildById = ui_3:getChildById(childPointers)
			getChildById:hide()
		end
	end
end

PvPShowChild_1(false)
local config_3 = storage[panelName_2]
if not config_3["PvP_1"] then
  config_3["PvP_1"] = {}
end
local PvPConfig_1 = config_3["PvP_1"]
if not PvPConfig_1.spell then
	PvPConfig_1.spell = {}
	PvPConfig_1.delay = {}
	PvPConfig_1.cacheText = {}
end

--load pve config
if PvPConfig_1.area_text then
	ui_3:getChildById('PvE_TextEdit_AN'):setText(PvPConfig_1.area_text)
end
if PvPConfig_1.target_text then
	ui_3:getChildById('PvE_TextEdit_SN'):setText(PvPConfig_1.target_text)
end
if PvPConfig_1.target_delay then
	ui_3:getChildById('PvE_TextEdit_DL'):setText(PvPConfig_1.target_delay)
end
if PvPConfig_1.area_delay then
	ui_3:getChildById('PvE_TextEdit_ADL'):setText(PvPConfig_1.area_delay)
end
if PvPConfig_1.radius then
	ui_3:getChildById('PvE_TextEdit_RA'):setText(PvPConfig_1.radius)
end
if PvPConfig_1.radius then
	ui_3:getChildById('PvE_TextEdit_MTR'):setText(PvPConfig_1.minTargetRadius)
end

for i=1, 4 do
	local getSpell = PvPConfig_1.spell[i]
	if getSpell then
		ui_3:getChildById('PvP_Spell_'..i):setText(getSpell)
	end
	local getDelay = PvPConfig_1.delay[i]
	getDelay = tonumber(getDelay)
	if type(getDelay) == "number" then 
		ui_3:getChildById('PvP_Delay_'..i):setText(getDelay)
	end
end

if PvPConfig_1.SH_enabled then
	PvPShowChild_1(PvPConfig_1.SH_enabled)
end

local function PvP_delayTextChange_1(index)
	local getDelay = ui_3:getChildById('PvP_Delay_'..index):getText()
	getDelay = tonumber(getDelay)
	if type(getDelay) ~= "number" then
		getDelay = 1000 * index
		ui_3:getChildById('PvP_Delay_'..index):setText(getDelay)
	end
	PvPConfig_1.delay[index] = getDelay  
end

ui_3.PvP_ShowHide:setOn(PvPConfig_1.SH_enabled)
ui_3.PvP_ShowHide.onClick = function(widget)
  if PvPConfig_1.SH_enabled then
	PvPConfig_1.SH_enabled = not PvPConfig_1.SH_enabled
	ui_3.PvP_ShowHide:setOn(PvPConfig_1.SH_enabled)
	PvPShowChild_1(PvPConfig_1.SH_enabled)
  else
	PvPConfig_1.SH_enabled = not PvPConfig_1.SH_enabled
	ui_3.PvP_ShowHide:setOn(PvPConfig_1.SH_enabled)
	PvPShowChild_1(PvPConfig_1.SH_enabled)
  end
end

ui_3.PvPAtk:setOn(PvPConfig_1.enabled)
ui_3.PvPAtk.onClick = function(widget)
	PvPConfig_1.enabled = not PvPConfig_1.enabled
	widget:setOn(PvPConfig_1.enabled)
	for i=1, 4 do
		PvPConfig_1.spell[i] = ui_3:getChildById('PvP_Spell_'..i):getText()
		PvP_delayTextChange_1(i)
	end
end

ui_3.PvP_Spell_1.onTextChange = function()
  PvPConfig_1.spell[1] = ui_3:getChildById('PvP_Spell_1'):getText()
end
ui_3.PvP_Spell_2.onTextChange = function()
  PvPConfig_1.spell[2] = ui_3:getChildById('PvP_Spell_2'):getText()
end
ui_3.PvP_Spell_3.onTextChange = function()
  PvPConfig_1.spell[3] = ui_3:getChildById('PvP_Spell_3'):getText()
end
ui_3.PvP_Spell_4.onTextChange = function()
  PvPConfig_1.spell[4] = ui_3:getChildById('PvP_Spell_4'):getText()
end

ui_3.PvP_Delay_1.onTextChange = function()
  PvP_delayTextChange_1(1)  
end
ui_3.PvP_Delay_2.onTextChange = function()
  PvP_delayTextChange_1(2)   
end
ui_3.PvP_Delay_3.onTextChange = function()
  PvP_delayTextChange_1(3)    
end
ui_3.PvP_Delay_4.onTextChange = function()
  PvP_delayTextChange_1(4)  
end

local function castCombo(spellName)
	if not spellName then return end
	TargetBot.sayAttackSpell(spellName, 0)
end

local getPanelComboBox_1 = ui_3:getChildById("botConfig")
for i=1, 12 do
	getPanelComboBox_1.list:addOption('F'..i)
end
local getChoiceKey_1 = PvPConfig_1.choiceKey
getPanelComboBox_1.list:setText(getChoiceKey_1 and getChoiceKey_1 or "F1")

ui_3.botConfig.list.onTextChange = function()
	PvPConfig_1.choiceKey = getPanelComboBox_1.list:getText()
end

local function PVP_clearTextTile(tile)
	local currTile = table.find(PvPConfig_1.cacheText, tile)
	if not currTile then return end
	PvPConfig_1.cacheText[currTile]:setText('')
	table.remove(PvPConfig_1.cacheText, currTile)
end

onKeyPress(function(keys)
	if PvPConfig_1.enabled and keys == getPanelComboBox_1.list:getText() then
		local isCasted = false
		for i=1, 4 do
			local getDelay = PvPConfig_1.delay[i]
			if getDelay then
				isCasted = true
				schedule(getDelay, function()
					castCombo(PvPConfig_1.spell[i])
				end)
			end
		end
		if isCasted then
			local pos = player:getPosition()
			local tile = g_map.getTile(pos)
			local currTile = table.find(PvPConfig_1.cacheText, tile)
			if not currTile then
				table.insert(PvPConfig_1.cacheText, tile)
				PvPConfig_1.cacheText[#PvPConfig_1.cacheText]:setText("Cast Combo I", 'red')
				schedule(1000, function()
					PVP_clearTextTile(tile)
				end)
			end
		end
	end
end)
-----------
local ui_4 = UI.createWidget("PvPBotPanel_2")
if not PvP_Config_2 then
	PvP_Config_2 = {}
	local getSHChild = ui_4:getChildren()
	if getSHChild then
		for i=1, #getSHChild do
			local childPointers = getSHChild[i]
			local getStyleName = childPointers:getStyleName()
			if table.contains({"BotSwitch", "Label", "BotTextEdit", "HorizontalSeparator"}, getStyleName, true) then
				local getChildById = childPointers:getId()
				if getChildById ~= "PvP_ShowHide" then
					PvP_Config_2[#PvP_Config_2 + 1] = getChildById
				end
			end
		end
		
		PvP_Config_2[#PvP_Config_2 + 1] = "botConfig"
	end
end

local function PvPShowChild_2(show)
	if show then
		for i=1, #PvP_Config_2 do
			local childPointers = PvP_Config_2[i]
			local getChildById = ui_4:getChildById(childPointers)
			getChildById:show()
		end
	else
		for i=1, #PvP_Config_2 do
			local childPointers = PvP_Config_2[i] 
			local getChildById = ui_4:getChildById(childPointers)
			getChildById:hide()
		end
	end
end

PvPShowChild_2(false)
local config_4 = storage[panelName_2]
if not config_4["PvP_2"] then
  config_4["PvP_2"] = {}
end
local PvPConfig_2 = config_4["PvP_2"]
if not PvPConfig_2.spell then
	PvPConfig_2.spell = {}
	PvPConfig_2.delay = {}
	PvPConfig_2.cacheText = {}
end

for i=1, 4 do
	local getSpell = PvPConfig_2.spell[i]
	if getSpell then
		ui_3:getChildById('PvP_Spell_'..i):setText(getSpell)
	end
	local getDelay = PvPConfig_2.delay[i]
	getDelay = tonumber(getDelay)
	if type(getDelay) == "number" then 
		ui_3:getChildById('PvP_Delay_'..i):setText(getDelay)
	end
end

if PvPConfig_2.SH_enabled then
	PvPShowChild_2(PvPConfig_2.SH_enabled)
end

local function PvP_delayTextChange_1(index)
	local getDelay = ui_4:getChildById('PvP_Delay_'..index):getText()
	getDelay = tonumber(getDelay)
	if type(getDelay) ~= "number" then
		getDelay = 1000 * index
		ui_4:getChildById('PvP_Delay_'..index):setText(getDelay)
	end
	PvPConfig_2.delay[index] = getDelay  
end

ui_4.PvP_ShowHide:setOn(PvPConfig_2.SH_enabled)
ui_4.PvP_ShowHide.onClick = function(widget)
  if PvPConfig_2.SH_enabled then
	PvPConfig_2.SH_enabled = not PvPConfig_2.SH_enabled
	ui_4.PvP_ShowHide:setOn(PvPConfig_2.SH_enabled)
	PvPShowChild_2(PvPConfig_2.SH_enabled)
  else
	PvPConfig_2.SH_enabled = not PvPConfig_2.SH_enabled
	ui_4.PvP_ShowHide:setOn(PvPConfig_2.SH_enabled)
	PvPShowChild_2(PvPConfig_2.SH_enabled)
  end
end

ui_4.PvPAtk:setOn(PvPConfig_2.enabled)
ui_4.PvPAtk.onClick = function(widget)
	PvPConfig_2.enabled = not PvPConfig_2.enabled
	widget:setOn(PvPConfig_2.enabled)
	for i=1, 4 do
		PvPConfig_2.spell[i] = ui_4:getChildById('PvP_Spell_'..i):getText()
		PvP_delayTextChange_1(i)
	end
end

ui_4.PvP_Spell_1.onTextChange = function()
  PvPConfig_2.spell[1] = ui_4:getChildById('PvP_Spell_1'):getText()
end
ui_4.PvP_Spell_2.onTextChange = function()
  PvPConfig_2.spell[2] = ui_4:getChildById('PvP_Spell_2'):getText()
end
ui_4.PvP_Spell_3.onTextChange = function()
  PvPConfig_2.spell[3] = ui_4:getChildById('PvP_Spell_3'):getText()
end
ui_4.PvP_Spell_4.onTextChange = function()
  PvPConfig_2.spell[4] = ui_4:getChildById('PvP_Spell_4'):getText()
end

ui_4.PvP_Delay_1.onTextChange = function()
  PvP_delayTextChange_1(1)  
end
ui_4.PvP_Delay_2.onTextChange = function()
  PvP_delayTextChange_1(2)   
end
ui_4.PvP_Delay_3.onTextChange = function()
  PvP_delayTextChange_1(3)    
end
ui_4.PvP_Delay_4.onTextChange = function()
  PvP_delayTextChange_1(4)  
end

local function castCombo(spellName)
	if not spellName then return end
	TargetBot.sayAttackSpell(spellName, 0)
end

local getPanelComboBox_2 = ui_4:getChildById("botConfig")
for i=1, 12 do
	getPanelComboBox_2.list:addOption('F'..i)
end

local getChoiceKey_2 = PvPConfig_2.choiceKey
getPanelComboBox_2.list:setText(getChoiceKey_2 and getChoiceKey_2 or "F1")

ui_4.botConfig.list.onTextChange = function()
	PvPConfig_2.choiceKey = getPanelComboBox_2.list:getText()
end

local function PVP_clearTextTile(tile)
	local currTile = table.find(PvPConfig_2.cacheText, tile)
	if not currTile then return end
	PvPConfig_2.cacheText[currTile]:setText('')
	table.remove(PvPConfig_2.cacheText, currTile)
end

onKeyPress(function(keys)
	if PvPConfig_2.enabled and keys == getPanelComboBox_2.list:getText() then
		if PvPConfig_1.enabled then 
			if getPanelComboBox_2.list:getText() == getPanelComboBox_1:getText() then
				return
			end
		end
		local isCasted = false
		for i=1, 4 do
			local getDelay = PvPConfig_2.delay[i]
			if getDelay then
				isCasted = true
				schedule(getDelay, function()
					castCombo(PvPConfig_2.spell[i])
				end)
			end
		end
		if isCasted then
			local pos = player:getPosition()
			local tile = g_map.getTile(pos)
			local currTile = table.find(PvPConfig_2.cacheText, tile)
			if not currTile then
				table.insert(PvPConfig_2.cacheText, tile)
				PvPConfig_2.cacheText[#PvPConfig_2.cacheText]:setText("CastCombo II", 'red')
				schedule(1000, function()
					PVP_clearTextTile(tile)
				end)
			end
		end
	end
end)